JUMPNEAR STRUCT
opcd BYTE ?
reladdr DWORD ?
JUMPNEAR ENDS

global_hook_cnt = 0

;    
;     
;( - )
;func -   
;args -  
;have_prologue -    
;( ,       mov edi,edi, push ebp; mov ebp, esp)
;(        0,    )

HOOK_ORIGINAL_CALL MACRO func:REQ, args:=< 0 >, have_prologue:=< 1 >
	cnt = 0
	REPEAT args
	  push [ebp+(&args - cnt + 1)*4]
	  cnt = cnt + 1
	ENDM

	push offset @CatStr(next_inst_, %global_hook_cnt)

	IF have_prologue EQ 1
	  push ebp
	  mov ebp,esp
	ENDIF

	mov eax,@CatStr(&func, _hook)
	add eax,5
	jmp eax
	@CatStr(next_inst_, %global_hook_cnt):

	global_hook_cnt = global_hook_cnt + 1
ENDM


;    
;      
;(  )
;( - )
;func -   
;have_prologue -    
;(        0,    )
;params -   

HOOK_ORIGINAL_CALL_PARAM MACRO func:REQ, have_prologue:=< 1 >, params:VARARG
	count = 0
	FOR xparam, <params>
	  count = count + 1
	  @CatStr(var,%count) TEXTEQU @CatStr(&xparam)
	ENDM

	REPEAT count
	  push @CatStr(var,%count)
	  count = count - 1
	ENDM

	push offset @CatStr(next_inst_, %global_hook_cnt)

	IF have_prologue EQ 1
	  push ebp
	  mov ebp,esp
	ENDIF

	mov eax,@CatStr(&func, _hook)
	add eax,5
	jmp eax
	@CatStr(next_inst_, %global_hook_cnt):

	global_hook_cnt = global_hook_cnt + 1
ENDM

;   
;( - )
;lib -  ,    
;func -  
;hook_label -  ,      
;ifload -     (0  )
;have_prologue -    
;(        0,    )


SET_HOOK MACRO lib:REQ, func:REQ, hook_label:REQ, ifload:=< 0 >, have_prologue:=< 1 >
	%ECHO [The hook on &func is SET on @CatStr(%@Line) Line]

	.data?
	@CatStr(libn, %global_hook_cnt) dd ?

	IFNDEF &func&_hook_
	  @CatStr(&func, _hook) dd ?
	  @CatStr(&func, _hook_) EQU <1>
	ENDIF

	IF have_prologue EQ 0
	  IFNDEF &func&_prologue_
	    @CatStr(&func, _prologue1) dw ?
	    @CatStr(&func, _prologue2) db ?
	    @CatStr(&func, _prologue3) dw ?
	    @CatStr(&func, _prologue_) EQU <1>
	  ENDIF
	ENDIF

	@CatStr(protect_, %global_hook_cnt) dd ?

	.code
	IF ifload EQ 1
	  mov @CatStr(libn, %global_hook_cnt), FUNC(LoadLibrary,chr$("&lib"))
	ELSE
	  mov @CatStr(libn, %global_hook_cnt), FUNC(GetModuleHandle,chr$("&lib"))
	ENDIF

	mov @CatStr(&func, _hook), FUNC(GetProcAddress, @CatStr(libn, %global_hook_cnt), chr$("&func"))

	invoke VirtualProtect, @CatStr(&func, _hook), sizeof JUMPNEAR, PAGE_READWRITE,  offset @CatStr(protect_, %global_hook_cnt)

	mov eax, @CatStr(&func, _hook)

	IF have_prologue EQ 0
	  mov cx, word ptr [eax]
	  mov @CatStr(&func, _prologue1), cx
	  mov cl, byte ptr [eax+2]
	  mov @CatStr(&func, _prologue2), cl
	  mov cx, word ptr [eax+3]
	  mov @CatStr(&func, _prologue3), cx
	ENDIF

	assume eax: ptr JUMPNEAR
	mov [eax].opcd, 0e9h
	mov ecx, offset &hook_label
	sub ecx,@CatStr(&func, _hook)
	sub ecx,5
	mov [eax].reladdr,ecx
	assume eax:nothing

	invoke VirtualProtect, @CatStr(&func, _hook), sizeof JUMPNEAR, @CatStr(protect_, %global_hook_cnt), offset @CatStr(protect_, %global_hook_cnt)

	global_hook_cnt = global_hook_cnt + 1
ENDM

;   
;( - )
;func -  
;have_prologue -    
;(        0,    )

REMOVE_HOOK MACRO func:REQ, have_prologue:=< 1 >
	%ECHO [The hook on &func is REMOVED on @CatStr(%@Line) Line]

	.data?
	@CatStr(protect_, %global_hook_cnt) dd ?

	.code
	invoke VirtualProtect, @CatStr(&func, _hook), sizeof JUMPNEAR, PAGE_READWRITE,  offset @CatStr(protect_, %global_hook_cnt)

	mov eax, @CatStr(&func, _hook)

	IF have_prologue EQ 0
	  mov cx, @CatStr(&func, _prologue1)
	  mov word ptr [eax], cx
	  mov cl, @CatStr(&func, _prologue2)
	  mov byte ptr [eax+2], cl
	  mov cx, @CatStr(&func, _prologue3)
	  mov word ptr [eax+3], cx
	ELSE
	  mov word ptr [eax], 0ff8bh
	  mov byte ptr [eax+2], 55h
	  mov word ptr [eax+3], 0e589h
	ENDIF

	invoke VirtualProtect, @CatStr(&func, _hook), sizeof JUMPNEAR, @CatStr(protect_, %global_hook_cnt), offset @CatStr(protect_, %global_hook_cnt)

	global_hook_cnt = global_hook_cnt + 1
ENDM
